Subject: 25.0.50; char-fold search broken for multi-line searches (sometimes)

From: Dima Kogan <[email-masked]>
Date: Thu, 30 Jul 2015 21:06:05 -0700

Hi. I'm using a very recent emacs built from the git HEAD. Sometime in
the recent past the default C-s behavior was changed to include
char-folding by default. There's a bug here. Suppose I have a buffer
containing the following C source.

----------------------------------------------------
int a(void)
{
  for(unsigned long x = 0;
      x < 10;
      x += 2)
  {
    nvm_flash_erase_app_page( x );
  }
}

int b(void)
{
  for(unsigned long x = 0;
      x < 10;
      x += 2)
  {
  }
}
----------------------------------------------------

Note that the two functions are identical. I place the point at the
start of one of the 'for' statements, then C-s to enter char-folding
isearch, then C-w to grab some amount of text to search for. While I'm
grabbing text that's still on the 'for' line, isearch sees the other
match, highlights it, and I can jump to it by hitting C-s. However, if I
hit C-w enough times to go to the next line, the other match is no
longer seen. This resolves when I turn off char-folding.